#include "comndata.h"

#define SW_TR BasicNode*
#define DL_TYPE DL_BasicNode

class BasicNode ;

class DL_TYPE
{
  protected:
    struct ListNode {
       SW_TR listNodeData;
       ListNode *prevNode;
       ListNode *nextNode;
    };

    ListNode *thisPtr,  // search node pointer
             *nodePtr,  // node-visitation pointer
             *tailPtr,  // pointer to the tailPtr of list
             *headPtr;  // pointer to headPtr of list
    unsigned nodeCount;      // number of nodes
    string80 errMsg;  // error message

    DL_TYPE& copy(DL_TYPE&);

  public:
    // ************** state manipulation methods **************
    DL_TYPE();
    DL_TYPE(DL_TYPE& dl)
      { headPtr = NULL; copy(dl); }
    // add virtual ~DoubleList()
    virtual ~DL_TYPE()
      { clear(); }

    // ****************** state query methods *****************
    bool isListEmpty() const
      { return (nodeCount == 0) ? true : false; }
    unsigned getNodeCount() const
      { return nodeCount; }
    char* getErrMsg();

    // ************** object manipulation methods *************
    virtual bool insert(SW_TR&);
    virtual bool insert(SW_TR&, SW_TR&) ;
    virtual bool remove(SW_TR& x, unsigned occur = 1);
    virtual bool search(SW_TR& x, unsigned occur = 1);
    virtual bool getFirstNode(SW_TR& x);
    bool getPrevNode(SW_TR& x);
    bool getPrevNode(SW_TR x, SW_TR& y);
    virtual bool getNextNode(SW_TR& x);
    virtual bool getNextNode(SW_TR x, SW_TR& y);
    bool getLastNode(SW_TR& x);
    bool getData(SW_TR& x,
                    unsigned index = 0,
                    bool updateNodePtr = false);
    virtual void clear();
    DL_TYPE& operator =(DL_TYPE& dl)
      { copy(dl); return *this; }
};

#undef SW_TR 
#undef DL_TYPE 

