#ifndef _QUEUE_HPP
#define _QUEUE_HPP

template<class T>
class Queue
{

  protected:
    // nested structure
    struct QueueNode {
        T nodeData;
        QueueNode *nextPtr;
    };

    int length;   // length of queue
    bool allocateError; // dynamic allocation error
    QueueNode *head ; // pointer to the head of the queue 
    QueueNode *tail ; // pointer to the tail of the queue 
    Queue<T>& copy(Queue<T>&);

  public:
    Queue();
    ~Queue()
      { clear(); }
    /* ****************** state query methods ***************** */
    bool isempty() const {
        return (length == 0) ? true : false;
    }
    bool getAllocateError() const
      { return allocateError; }

    /* ************** object manipulation methods ************* */
    void add(T) ;
    bool remove(T&);
    void clear();
    Queue<T>& operator =(Queue<T>& g)
      { copy(g); return *this; }
};

#endif
