/************************************************************
 * swerror.h -- Swan system errors			    *
 * Jun Yang, November 17, 1994				    *
 ************************************************************/

/*--------------- Types ---------------*/

struct _error_message {
        int     index ;
        char*   message ;
} ;

/*--------------- External Variables ---------------*/

extern int _sw_errno ;
extern char _errorstr[] ;
extern struct _error_message _sw_error_list[] ;

/*--------------- Error Indices ---------------*/

#define SWE_INTN	1	// Swan internal errors
#define SWE_NOCONNECT	2	// Connection to Swan is refuesed
#define SWE_NOMEMORY    3	// No enough memory

#define SWE_NOGRAPH	11	// Invalid graph ID
#define SWE_NONODE	12	// Invalid node ID
#define SWE_NOEDGE	13	// Invalid edge ID
#define SWE_NOLC	14	// Invalid layout component ID
#define SWE_NOATTR	15	// Invalid attribute specification
#define SWE_BADGRAPHID	16	// graph id already used
#define SWE_BADLCID	17	// lc id already used
#define SWE_NONBNODE	18	// no such neighbour node
#define SWE_BADMENUITEM 19	// no such menu item
#define SWE_INVRECT	21	// Incorrect rectangle type 
#define SWE_INVELLIPSE	22	// Incorrect ellipse type
#define SWE_INVNODE	23	// Invalid node type

#define SWE_REDEFNODE   31	// Node already existed
#define SWE_REDEFEDGE	32	// Edge already existed
#define SWE_MORENODES	33	// Too many nodes

/*--------------- Function Prototypes ----------------*/

bool _sw_geterrormsg(int, char*) ;

/************************************************************
 *  End of swerror.h			         	    *
 ************************************************************/
